/*
    Clip area compatible with J2ME
    Copyright (C) 2003 Irene Cummings (i.n.c@ezrs.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package inc.games;

public class ClipArea
{
	public final int m_ClipXReset;
	public final int m_ClipYReset;
	public final int m_ClipWReset;
	public final int m_ClipHReset;
	private int m_ClipX;
	private int m_ClipY;
	private int m_ClipH;
	private int m_ClipW;

	public ClipArea(int sizeW,int sizeH)
	{
		m_ClipXReset=0;
		m_ClipYReset=0;
		m_ClipWReset=sizeW;
		m_ClipHReset=sizeH;
		m_ClipX=m_ClipXReset;
		m_ClipY=m_ClipYReset;
		m_ClipW=m_ClipWReset;
		m_ClipH=m_ClipHReset;
	}

	//clip area functionality

	//Add blk to clipping area. 
	public void AddClipArea(int x, int y, int w, int h)
	{
		int xE0=m_ClipX+m_ClipW;
		int yE0=m_ClipY+m_ClipH;
		int xE1=x+w;
		int yE1=y+h;
		m_ClipX=(m_ClipX>x)? x:m_ClipX;  
		m_ClipY=(m_ClipY>y)? y:m_ClipY;  
		m_ClipW=(xE1>xE0)? xE1-m_ClipX:xE0-m_ClipX;
		m_ClipH=(yE1>yE0)? yE1-m_ClipY:yE0-m_ClipY;
	}

	public void Reset()
	{
		m_ClipX=m_ClipXReset;
		m_ClipY=m_ClipYReset;
		m_ClipW=m_ClipWReset;
		m_ClipH=m_ClipHReset;
	}

	public int GetX()
	{
		return m_ClipX;
	}

	public int GetY()
	{
		return m_ClipY;
	}

	public int GetW()
	{
		return m_ClipW;
	}

	public int GetH()
	{
		return m_ClipH;
	}
}








